# class Crystal::Macros::MacroFor

- Crystal::Macros::MacroFor
- Crystal::Macros::ASTNode

##
Overview

A `for` loop inside a macro, e.g.

    {% for x in exp %}
      puts {{x}}
    {% end %}

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #body : ASTNode

  The body of the `for` loop.

- #exp : ASTNode

  The expression after `in`.

- #vars : ArrayLiteral(Var)

  The variables declared after `for`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def body : ASTNode #

The body of the `for` loop.

def exp : ASTNode #

The expression after `in`.

def vars : ArrayLiteral(Var) #

The variables declared after `for`.